CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000

OBJ
     log: "Autodatalogger_Neg_Num_Final"
  serial: "FullDuplexSerial"
  
VAR
  long  index
  long  Pressure, Pressure1, RPM
PUB null

  dira[17]~~
  serial.start(31, 30, %0000, 115200)
  waitcnt(clkfreq*3 + cnt)
  
  repeat
    log_start                                           ' start log
             
    delay(3)                                            ' for 3 sec
             
    log_stop                                            ' stop
    log_stop                                            ' redundant but shouldn't break
             
    delay(2)                                            ' take a break
             
    log_start                                           ' start again
             
    delay(5)                                            ' for 5 sec
             
    log_stop                                            ' stop
             
    delay(4)                                            ' repeat after break
  
PRI delay(sec) : t

  t := cnt
  repeat sec
    waitcnt(t += clkfreq/2)
    !outa[17]
    waitcnt(t += clkfreq/2)
    !outa[17]
    
PRI log_start : n

  repeat 8
    name[n++] := lookupz((index <-= 4) & $F : "0".."9", "A".."F")
  index++
  
  serial.str(@name{0})                                  ' |
  serial.tx(13)                                         ' debug only
  
  log.init(0, 1, 2, @name{0}, 10_000)
  log.addfield(@pressure, 2, string("Raw"))
  log.addfield(@RPM, 4, string("RPM"))
  log.addfield(NEGX|@Pressure1, 2, string("corrected"))
  'log.addfield(0, 0, 0)
  'log.addfield(0, 0, 0)
  'log.start

PRI log_stop

  log.stop

DAT

name    byte    "Pressure.log", 0

DAT